<?php
/**
* @version		$ 1.2 2009-10$
* @package		Joomla
* @subpackage	IPricecalc
* @copyright	Copyright (C) 2009 LoT studio group. All rights reserved.
* @license		The commercial licence http://www.lot-studio.ru/license-ipricecalc
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );

require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'tables'.DS.'ipricecalc.php');

class IPricecalcControllerCurr extends JController
{
	/**
	 * Constructor
	 */
	function __construct( $config = array() )
	{
		parent::__construct( $config );
		// Register Extra tasks
		$this->registerTask( 'add',			'edit' );
		$this->registerTask( 'apply',		'save' );
	}

	/**
	 * Display the list of banners
	 */
	function display()
	{
		global $mainframe;

		$db =& JFactory::getDBO();

		$context			= 'com_ipricecalc.currency';
		$table =& JTable::getInstance('Iprice_curr', 'JTable');
		
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order', 		'filter_order', 	'currcode',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$filter_state 		= $mainframe->getUserStateFromRequest( $context.'filter_state', 		'filter_state', 	'',				'word' );
		$filter_catid 		= $mainframe->getUserStateFromRequest( $context.'filter_catid', 		'filter_catid',		0,				'int' );
		$search 			= $mainframe->getUserStateFromRequest( $context.'search', 			'search', 			'',				'string' );
		$search 			= JString::strtolower( $search );
		
		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest($context.'.limitstart', 'limitstart', 0, 'int');
		
		$table->SetQuery($filter_state,$filter_catid, $search, $filter_order, $filter_order_Dir);
		$total = $table->GetCount();

		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );

		$rows = $table->GetList($pageNav->limitstart, $pageNav->limit );

		// build list of categories
		$javascript = 'onchange="document.adminForm.submit();"';

		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;

		// search filter
		$lists['search']= $search;
		
		require_once(JPATH_COMPONENT.DS.'views'.DS.'curr.php');		
		IPricecalcViewCurr::Currency( $rows, $pageNav, $lists );		

//		HTML_ipricecalc::showIPrice( $rows, $pageNav, $context, $lists );
		
	}

	function edit()
	{
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$edit = ($this->_task == 'edit');
		if ($edit) {
			$cid	= substr(JRequest::getVar('cid', '', 'method', 'string'),0,3);
		} else {
			$cid	= '';
		}
	
		$option = JRequest::getCmd('option');

		$row =& JTable::getInstance('Iprice_curr', 'JTable');
		// load the row from the db table
		
		$row->load( $cid );

		if ($edit) {
			// do stuff for existing records
			$row->checkout($user->get('id'));
		} else {
			// do stuff for new records
			$row->ordering 	= 0;
		}
		$lists = array();

		// build the html select list for ordering
	//	HTML_ipricecalc::editIPrice( $row, $lists, $option, $params );

		require_once(JPATH_COMPONENT.DS.'views'.DS.'curr.php');
		IPricecalcViewCurr::CurrencyItem( $row, $lists, $params);
	}

	/**
	 * Save method
	 */
	function save()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('Iprice_curr', 'JTable');
		$post = JRequest::get( 'post' );
		
	
		// fix up special html fields
		if (!$row->bind( $post )) {
			JError::raiseError(500, $row->getError() );
		}
		$row->currdate = date('Y.m.d H:i:s');
		// save params

		// pre-save checks
		if (!$row->check()) {
			JError::raiseError(500, $row->getError() );
		}

		// save the changes
		if ($post['edit']) {
			if (!$row->store()) {		
				JError::raiseError(500, $row->getError() );
			}
		} else {
			if (!$row->insert()) {
				JError::raiseError(500, $row->getError() );
			}
		}
		$row->checkin();

		$task = JRequest::getCmd( 'task' );
	
		switch ($task)
		{
			case 'apply':
			case 'save2copy':
				$msg	= JText::sprintf( 'Changes to X saved', JText::_('Currency Item') );
				$link	= 'index.php?option=com_ipricecalc&c=curr&task=edit&cid='. $row->currcode .'';
				break;

			case 'save2new':
				$msg	= JText::sprintf( 'Changes to X saved', JText::_('Contact') );
				$link	= 'index.php?option=com_ipricecalc&task=edit';
				break;

			case 'save':
			default:
				$msg	= JText::_( 'Currency item saved' );
				$link	= 'index.php?option=com_ipricecalc&c=curr';
				break;
		}

		$this->setRedirect( $link, $msg );
	}

	function cancel()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$this->setRedirect( 'index.php?option=com_ipricecalc&c=curr' );
		// Initialize variables
		$db =& JFactory::getDBO();
		$row =& JTable::getInstance('Iprice_curr', 'JTable');
		$row->bind( JRequest::get( 'post' ));
		$row->checkin();
	}

	/**
	 * Copies one or more banners
	 */
	function copy()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_ipricecalc' );
	}

	function remove()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=curr' );

		// Initialize variables
		$db =& JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$n		= count( $cid );
		for ($i=0;$i<$n;$i++)
			$cid[$i]='"'.substr($cid[$i],0,3).'"';

		if (count( $cid )) {
			$cids = implode( ',', $cid );
			$query = 'DELETE FROM #__iprice_curr'
			. ' WHERE currcode IN ( '. $cids .' )'
			;
			echo $query;
			$db->setQuery( $query );
			if (!$db->query()) {
				JError::raiseWarning( 500, $db->getError() );
			}
		}
		$this->setMessage( JText::sprintf( 'Currency items removed', $n ) );
	}

}
