<?php
/**
* @version		$ 1.2 2009-10$
* @package		Joomla
* @subpackage	IPricecalc
* @copyright	Copyright (C) 2009 LoT studio group. All rights reserved.
* @license		The commercial licence http://www.lot-studio.ru/license-ipricecalc
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );

require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'tables'.DS.'ipricecalc.php');
require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'tables'.DS.'category.php');
require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'tables'.DS.'section.php');
require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'helpers'.DS.'html.php');
require_once(JPATH_COMPONENT.DS.'views'.DS.'item.php');

class IPricecalcControllerItem extends JController
{
	/**
	 * Constructor
	 */
	function __construct( $config = array() )
	{
		parent::__construct( $config );
		// Register Extra tasks
		$this->registerTask( 'add',			'edit' );
		$this->registerTask( 'apply',		'save' );
		$this->registerTask( 'unpublish',	'publish' );
		$this->registerTask( 'copysave',	'copysave' );
		$this->registerTask( 'saveorder',	'saveorder' );		
		$this->registerTask( 'orderup',		'reorder' );
		$this->registerTask( 'orderdown',	'reorder' );
		$this->registerTask( 'saveprice',	'saveprice' );
	}

	function display()
	{
		global $mainframe;

		$db =& JFactory::getDBO();

		$context			= 'com_ipricecalc.items';
		$table =& JTable::getInstance('Iprice_item', 'JTable');
		
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order',	'filter_order',	'ipi.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir', 'filter_order_Dir',	'', 'word' );
		$filter_state 		= $mainframe->getUserStateFromRequest( $context.'filter_state',	'filter_state',	'','word' );
		$filter_catid 		= $mainframe->getUserStateFromRequest( $context.'filter_catid',	'filter_catid',	'', 'string' );
		$filter_secid		= $mainframe->getUserStateFromRequest( $context.'filter_secid', 'filter_secid',	'', 'string');
		$search 			= $mainframe->getUserStateFromRequest( $context.'search', 'search', '',	'string' );
		$search 			= JString::strtolower( $search );
		
		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest($context.'.limitstart', 'limitstart', 0, 'int');

		$table->SetQuery($filter_state,$filter_secid, $filter_catid, $search, $filter_order, $filter_order_Dir);
		$total = $table->GetCount();

		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );

		$rows = $table->GetList($pageNav->limitstart, $pageNav->limit );

		// build list of categories
		$javascript = 'onchange="document.adminForm.submit();"';
		$lists['secid'] = JHTMLIpriceList::section('filter_secid', intval( $filter_secid ), $javascript);
//		$lists['secid'] = JHTML::_('list.section',  'filter_secid', intval( $filter_secid ), $javascript, 'ordering', false , "ipricecalc");
		$lists['catid'] = JHTMLIpriceList::category('filter_catid', intval( $filter_catid ), $javascript, intval( $filter_secid ));

		// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );

		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;

		// search filter
		$lists['search']= $search;
		
		require_once(JPATH_COMPONENT.DS.'views'.DS.'item.php');		
		IPricecalcViewItem::Items( $rows, $pageNav, $lists );		

//		HTML_ipricecalc::showIPrice( $rows, $pageNav, $context, $lists );
		
	}

	function edit()
	{
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$contentSection	= '';
		
		$edit = ($this->_task == 'edit');
		if ($edit) {
			$cid	= JRequest::getVar('cid', array(0), 'method', 'array');
			$cid	= array((int) $cid[0]);
		} else {
			$cid	= array( 0 );
		}
	
		$option = JRequest::getCmd('option');

		JArrayHelper::toInteger($cid, array(0));

		$row =& JTable::getInstance('Iprice_item', 'JTable');
		// load the row from the db table
		$row->load( $cid[0] );

		if ($edit) {
			// do stuff for existing records
			$row->checkout($user->get('id'));
		} else {
			// do stuff for new records
			$row->ordering 	= 0;
		}
		$lists = array();

		// build the html select list for ordering
		$query = $row->GetOrderQuery($row->catid);
		if($edit)
			$lists['ordering'] 			= JHTML::_('list.specificordering',  $row, $cid[0], $query );
		else
			$lists['ordering'] 			= JHTML::_('list.specificordering',  $row, '', $query );


// Build section - category list
		$javascript = "onchange=\"changeDynaList( 'catid', sectioncategories, document.adminForm.secid.options[document.adminForm.secid.selectedIndex].value, 0, 0);\"";

		$cattable = & JTable::getInstance('Iprice_category', 'JTable');
		$cattable->SetQuery('PP',NULL,NULL,NULL,NULL,' ipc.id = '.$row->catid);
		$catrow = $cattable->GetList();

		if (isset($catrow[0]->secid))
			$secid = $catrow[0]->secid;
		else 
			$secid = -1;

		$query = 'SELECT distinct ips.id, ips.name' .
				' FROM #__iprice_sections ips' .
				' INNER JOIN #__iprice_categories ipc ON ipc.secid=ips.id' .
				' ORDER BY ips.ordering';
		$db->setQuery($query);
		$sec_list = $db->loadObjectList();

		$sections[] = JHTML::_('select.option', '-1', '- '.JText::_('Select Section').' -', 'id', 'name');

		$sections = array_merge($sections, $sec_list);

		$lists['secid'] = JHTML::_('select.genericlist',  $sections, 'secid', 'class="inputbox" size="1" '.$javascript, 'id', 'name', intval($secid));
		$lists['discid'] = JHTMLIpriceList::discount('discid', intval( $row->discid ));

		foreach ($sections as $section)
		{
			$section_list[] = (int) $section->id;
			// get the type name - which is a special category
			if ($secid) {
				if ($section->id == $secid) {
					$contentSection = $section->name;
				}
			}
		}

		$sectioncategories = array ();
		$sectioncategories[-1] = array ();
		$sectioncategories[-1][] = JHTML::_('select.option', '-1', JText::_( 'Select Category' ), 'id', 'name');
		$section_list = implode('\', \'', $section_list);

		$query = 'SELECT id, name , secid' .
				' FROM #__iprice_categories' .
				' WHERE secid IN ( \''.$section_list.'\' )' .
				' ORDER BY ordering';
		$db->setQuery($query);
		$cat_list = $db->loadObjectList();

		foreach ($sections as $section)
		{
			$sectioncategories[$section->id] = array ();
			$rows2 = array ();
			foreach ($cat_list as $cat)
			{
				if ($cat->secid == $section->id) {
					$rows2[] = $cat;
				}
			}
			foreach ($rows2 as $row2) {
				$sectioncategories[$section->id][] = JHTML::_('select.option', $row2->id, $row2->name, 'id', 'name');
			}
		}
		$sectioncategories['-1'][] = JHTML::_('select.option', '-1', JText::_( 'Select Category' ), 'id', 'name');
		$categories = array();
		foreach ($cat_list as $cat) {
			if($cat->secid == $secid)
				$categories[] = $cat;
		}

		$categories[] = JHTML::_('select.option', '-1', '- '.JText::_( 'Select Category' ) .' -', 'id', 'name');
		$lists['catid'] = JHTML::_('select.genericlist',  $categories, 'catid', 'class="inputbox" size="1"', 'id', 'name', intval($row->catid));
		$lists['item_type'] = JHTMLIpriceList::item_type('item_type', intval($row->item_type));
//End  Build section - category list
	
		$lists['published'] 		= JHTML::_('select.booleanlist',  'published', '', $row->published );
		$lists['enable_file'] 		= JHTML::_('select.booleanlist',  'enable_file', '', $row->enable_file );

		// get params definitions
		$file 	= JPATH_ADMINISTRATOR .'/components/com_ipricecalc/ipricecalc_items.xml';
		$params = new JParameter( $row->params, $file, 'component' );

	//	HTML_ipricecalc::editIPrice( $row, $lists, $option, $params );

		IPricecalcViewItem::Item( $row, $lists, $params, $contentSection, $sectioncategories);
	}

	/**
	 * Save method
	 */
	function save()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('Iprice_item', 'JTable');
		$post = JRequest::get( 'post' );
	
		// fix up special html fields
		$post['description'] = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );

		if (!$row->bind( $post )) {
			JError::raiseError(500, $row->getError() );
		}
		// save params
		$params = JRequest::getVar( 'params', array(), 'post', 'array' );
		if (is_array( $params )) {
			$txt = array();
			foreach ( $params as $k=>$v) {
				$txt[] = "$k=$v";
			}
			$row->params = implode( "\n", $txt );
		}

		// save to a copy, reset the primary key
		if ($task == 'save2copy') {
			$row->id = 0;
		}

		// pre-save checks
		if (!$row->check()) {
			JError::raiseError(500, $row->getError() );
		}

		// if new item, order last in appropriate group
		if (!$row->id) {
			$where = "catid = " . (int) $row->catid;
			$row->ordering = $row->getNextOrder( $where );
		}

		// save the changes
		if (!$row->store()) {
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin();

		$task = JRequest::getCmd( 'task' );
	
		switch ($task)
		{
			case 'apply':
			case 'save2copy':
				$msg	= JText::sprintf( 'Changes to X saved', JText::_('Price Item') );
				$link	= 'index.php?option=com_ipricecalc&task=edit&cid[]='. $row->id .'';
				break;

			case 'save2new':
				$msg	= JText::sprintf( 'Changes to X saved', JText::_('Contact') );
				$link	= 'index.php?option=com_ipricecalc&task=edit';
				break;

			case 'save':
			default:
				$msg	= JText::_( 'Price item saved' );
				$link	= 'index.php?option=com_ipricecalc';
				break;
		}


		$this->setRedirect( $link, $msg );
	}

	function cancel()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$this->setRedirect( 'index.php?option=com_ipricecalc' );
		// Initialize variables
		$db =& JFactory::getDBO();
		$row =& JTable::getInstance('Iprice_item', 'JTable');
		$row->bind( JRequest::get( 'post' ));
		$row->checkin();
	}

	function publish()
	{
		global $mainframe;
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_ipricecalc' );
	// Initialize variables
		$db 	=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		
		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$task		= JRequest::getCmd( 'task' );
		$publish	= ($task == 'publish');
		$n			= count( $cid );
		
		if (empty( $cid )) {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}
		JArrayHelper::toInteger($cid);
		$cids = implode( ',', $cid );
		
		$query = 'UPDATE #__iprice_item'
		. ' SET published = ' . (int) $publish
		. ' WHERE id IN ( '. $cids .' )'
		. ' AND ( checked_out = 0 OR ( checked_out = '. (int) $user->get('id') .' ) )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			JError::raiseError(500, $db->getErrorMsg() );
		}
		if (count( $cid ) == 1) {
			$row =& JTable::getInstance('Iprice_item', 'JTable');
			$row->checkin( intval( $cid[0] ) );
		}
		$this->setMessage( JText::sprintf( $publish ? 'Items published' : 'Items unpublished', $n ) );		
	}

	function remove()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_ipricecalc' );

		// Initialize variables
		$db =& JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$n		= count( $cid );
		JArrayHelper::toInteger( $cid );

		if (count( $cid )) {
			$cids = implode( ',', $cid );
			$query = 'DELETE FROM #__iprice_item'
			. ' WHERE id IN ( '. $cids .' )'
			;
			$db->setQuery( $query );
			if (!$db->query()) {
				JError::raiseWarning( 500, $db->getError() );
			}
		}
		$this->setMessage( JText::sprintf( 'Items removed', $n ) );
	}

	/**
	 * Save the new order given by user
	 */
	function reorder()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_ipricecalc' );
		
		$task	= JRequest::getCmd('task');
		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order		= JRequest::getVar( 'order', array(), 'post', 'array' );
		$inc = ($task == 'orderup' ? -1 : 1);
		$uid = (int) $cid[0];

		// Initialize variables
		$db =& JFactory::getDBO();

		$row =& JTable::getInstance('Iprice_item', 'JTable');
		$row->load( $uid );
		$row->move( $inc, 'catid = '. (int) $row->catid );

		$this->setMessage( JText::_('New ordering saved') );
	}
	
	function saveorder()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db			= & JFactory::getDBO();

		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$order		= JRequest::getVar( 'order', array (0), 'post', 'array' );
		$redirect	= JRequest::getVar( 'redirect', 0, 'post', 'int' );
		$rettask	= JRequest::getVar( 'returntask', '', 'post', 'cmd' );
		$total		= count($cid);
		$conditions	= array ();

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// Instantiate an article table object
		$row = & JTable::getInstance('Iprice_item', 'JTable');

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError( 500, $db->getErrorMsg() );
					return false;
				}
				// remember to updateOrder this group
				$condition = 'catid = '.(int) $row->catid;
				$found = false;
				foreach ($conditions as $cond)
					if ($cond[1] == $condition) {
						$found = true;
						break;
					}
				if (!$found)
					$conditions[] = array ($row->id, $condition);
			}
		}

		// execute updateOrder for each group
		foreach ($conditions as $cond)
		{
			$row->load($cond[0]);
			$row->reorder($cond[1]);
		}
		$this->setMessage( JText::_('New ordering saved') );
		$this->setRedirect( 'index.php?option=com_ipricecalc' );
	}
	
	function saveprice()
	{
		global $mainframe;
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		// Initialize variables
		$db			= & JFactory::getDBO();

		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$cost		= JRequest::getVar( 'cost', array (0), 'post', 'array' );
		$redirect	= JRequest::getVar( 'redirect', 0, 'post', 'int' );
		$rettask	= JRequest::getVar( 'returntask', '', 'post', 'cmd' );
		$total		= count($cid);
		$conditions	= array ();

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toString($cost, array(0));

		// Instantiate an article table object
		$row = & JTable::getInstance('Iprice_item', 'JTable');

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load( (int) $cid[$i] );
			$price = $cost[$i] + 0.00;
			if ($price) {
				$row->cost = $price;
				if (!$row->store()) {
					JError::raiseError( 500, $db->getErrorMsg() );
					return false;
				}
			}
		}
		$this->setMessage( JText::_('New prices saved') );
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=item' );
	}
	
	function copysave()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db			= & JFactory::getDBO();

		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$option		= JRequest::getCmd( 'option' );

		JArrayHelper::toInteger($cid);

		$item	= null;

		$total = count($cid);
		for ($i = 0; $i < $total; $i ++)
		{
			$row = & JTable::getInstance('Iprice_item');

			// main query
			$query = 'SELECT a.*' .
					' FROM #__iprice_item AS a' .
					' WHERE a.id = '.(int) $cid[$i];
			echo $query;
			$db->setQuery($query, 0, 1);
			$item = $db->loadObject();

			// values loaded into array set for store
			$row->id						= NULL;
			$row->catid						= $item->catid;
			$row->name						= JText::_("Copy")." ".$item->name;
			$row->item_type					= $item->item_type;
			$row->cost						= $item->cost;
			$row->showcount					= $item->showcount;
			$row->radiogroup				= $item->radiogroup;
			$row->discid					= $item->discid;
			$row->enable_file				= $item->enable_file;
			$row->ordering					= '0';
			$row->checked_out				= $item->checked_out;
			$row->checked_out_time			= $item->checked_out_time;
			$row->published					= $item->published;
			$row->shortdesc					= $item->shortdesc;
			$row->description				= $item->description;
			$row->params					= $item->params;

			if (!$row->check()) {
				JError::raiseError( 500, $row->getError() );
				return false;
			}

			if (!$row->store()) {
				JError::raiseError( 500, $row->getError() );
				return false;
			}
//			$row->reorder('catid='.(int) $row->catid.' AND state >= 0');
		}
//		exit;
		$this->setMessage( JText::_('Item(s) copied to new item(s)') );
		$this->setRedirect( 'index.php?option=com_ipricecalc&c=item' );
	}
	
}
