<?php

/**
* @version		$ 1.2 2009-10$
* @package		Joomla
* @subpackage	IPricecalc
* @copyright	Copyright (C) 2009 LoT studio group. All rights reserved.
* @license		The commercial licence http://www.lot-studio.ru/license-ipricecalc
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );
jimport( 'joomla.application.component.controller' );
jimport('joomla.mail.helper');	
require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'tables'.DS.'ipricecalc.php');
require_once( JPATH_SITE.DS.'components'.DS.'com_ipricecalc'.DS.'views'.DS.'basket'.DS.'view.html.php');
require_once( JPATH_SITE.DS.'components'.DS.'com_ipricecalc'.DS.'models'.DS.'basket.php');
require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ipricecalc'.DS.'helpers'.DS.'orderhtml.php');


class IPriceCalcController extends JController
{
	/**
	 * Display the view
	 */
	function display($contact = null, $filter = null, $cartmode = null)
	{
		$document =& JFactory::getDocument();
		$viewName	= JRequest::getVar('view', 'price', 'default', 'cmd');
		$layout		= JRequest::getCmd('layout');
		$itemid	= JRequest::getVar('itemid', '', 'default', 'cmd');
		
		$viewType	= $document->getType();

		// interceptors to support legacy urls

		switch ($this->getTask())
		{
			//index.php?option=com_contact&task=category&id=0&Itemid=4
			case 'makeorder':
				break;
		}

		// Set the default view name from the Request
		$view = &$this->getView($viewName, $viewType);

		// Push a model into the view
		$model	= &$this->getModel( $viewName );
		if (!JError::isError( $model )) {
			$view->setModel( $model, true );
		}
		// Display the view
		$view->assign('error', $this->getError());
		$view->assign('task',$this->getTask());
		if ($viewName == 'basket')
			$view->display(null, $itemid, $contact, $cartmode);
		else
			parent::display(false);
//		$view->display($layout, $itemid, $contact, $filter);
	}
	
	function AddToBasket( &$items, &$itemsall)
	{
		$table =& JTable::getInstance('Iprice_basket', 'JTable');
		$table->AddToBasket($items, $itemsall);
	}
	
	function prepareFiles(&$items)
	{
		if (!count($items)) return;
		$errmess = "";
		for ($i=0;$i<count($items); $i++) {
		
			$content_dir=str_replace(array('components/com_ipricecalc/','components\\com_ipricecalc\\'),'',dirname(__FILE__).DS."tmp".DS);
			$nm = 'filename_'.$items[$i]->id;

			$items[$i]->filename = JRequest::getVar( 'old_filename_'.$items[$i]->id,'','post' );
			$items[$i]->tmp_filename = JRequest::getVar( 'old_tmpfilename_'.$items[$i]->id,'','post' );
			$items[$i]->tmp_dirname = JRequest::getVar( 'old_tmpdirname_'.$items[$i]->id,'','post' );
			
			if (!count($_FILES)) continue;
			
			if (!$_FILES[$nm]['name']) {
				continue;
			}
				
			$tmp_file = $_FILES[$nm]['tmp_name'];
			
		    if( !is_uploaded_file($tmp_file) ) {
				$errmess .= "Error upload file ".$tmp_file."<br>";
		        continue;
			}

		    // on vérifie maintenant l'extension
		    $type_file = $_FILES[$nm]['type'];
		    $name_file = $_FILES[$nm]['name'];
		    $allowedExt = array("csv");
/*
		    if(!in_array(end(explode(".", $name_file)),$allowedExt))
			        exit(JText::_('ERROR_FILE2')." <a href=\"".JRoute::_('index.php?option=com_importcsv&view=process&tmpl=component')."\">".JText::_('Back')."</a>");
*/
			$tmp_filename = session_id().'-'.$name_file;
		    if( !move_uploaded_file($tmp_file,$content_dir . $tmp_filename) ) {
				$errmess .= "Error move file ".$tmp_file." to file ".$content_dir . $tmp_filename." <br>";
				continue;
			}
				
			$items[$i]->tmp_dirname = $content_dir;
			$items[$i]->tmp_filename = $tmp_filename;
			$items[$i]->filename = $name_file;
		}
		return $errmess;
 
	}

	function submit()
	{
		global $mainframe;
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$link = urldecode(JRequest::getVar( 'redir','','post' ));
		$itemid = JRequest::getVar( 'itemid','','post' );
		
		if ($itemid) {
		    $menu = & JMenu::getInstance('site');
			$menuitem = $menu->getItem($itemid);
			if ($menuitem && strpos($menuitem->link,'ipricecalc')) {
				$pparams = & $menu->getParams( $itemid );
				$globalparams = $mainframe->getPageParameters('com_ipricecalc');
				if ($globalparams) {
					$globalparams->merge($pparams);
					$pparams = $globalparams;
				}
			}
		} 
		if (!isset($pparams))
			$pparams = $mainframe->getPageParameters('com_ipricecalc');

		if (!$link)
			$link = 'index.php?option=com_ipricecalc&view=price';
			
//		$link = JRoute::_($link,false);

		$action = JRequest::getVar( 'actype','','post' );
		
		if ($action == 'emptycart') {
			IPriceCalcModelBasket::emptyBasket();
			$this->setRedirect($link, JText::_('Cart is empty'));
			return true;
		}
		
		if ($action == 'templatetocart') {
			$orderno = JRequest::getInt( 'orderno','0','post' );
			if ($orderno) 
				IPriceCalcModelBasket::insOrderToBasket( $orderno);
			$this->setRedirect($link);
			return true;
		}
		
		$usecart = JRequest::getInt( 'usecart','1','post' );
		$filter = htmlspecialchars(JRequest::getVar( 'ifilter','','post' ));

		if ($action == 'filter_sec') {
			$secid = JRequest::getInt( 'secid','0','post' );
			$catid = JRequest::getInt( 'catid','0','post' );
			$app	= &JFactory::getApplication();
			$router = &$app->getRouter();
			$uri = JFactory::getURI();
			if ($router) {
				$uri->setQuery($router->parse($uri));
			}
			$uri->delVar('isecid');
			$uri->delVar('icatid');
			$uri->delVar('start');
			$uri->delVar('limitstart');
			if ($secid) {
				$uri->setVar('isecid',$secid);
				if ($catid)
					$uri->setVar('icatid',$catid);
			}
			$ur = 'index.php'.$uri->toString(array('query'));
			$this->setRedirect(html_entity_decode(JRoute::_($ur)));
			return true;
		}
		
		if ($action == 'filter') {
			$uri = JFactory::getURI();
			$uri->delVar('ifilter');
			$uri->delVar('start');
			$uri->delVar('limitstart');
			if ($filter) {
				$uri->setVar('ifilter',$filter);
			}
			$this->setRedirect($uri->toString());
			return true;
		}
		
		if ($action == 'paging') {
			$viewName	= JRequest::getVar('view', 'price', 'default', 'cmd');
//			$limit = JRequest::getVar( 'limit','','post' );
//			if (!($limit === ''))
//				$this->getModel( $viewName )->_pagination->limit = $limit;
			$this->setRedirect($link);		
			return false;
		}

		// Initialize some variables
		$db			= & JFactory::getDBO();
		$SiteName	= $mainframe->getCfg('sitename');
		
		$countitems	= JRequest::getInt( 'countitems',0,'post' );
		$curr	= JRequest::getVar( 'curr','RUR','post' );
		$radiogroups = JTableIprice_item::GetRadioGroups();		
		$items = array();
		$itemsall = array();		

		$j = 0;
		for ($i=0;$i<$countitems;$i++) {
		   $chk = JRequest::getVar( 'i_box_'.$i,'','post' );
		   $cnt = JRequest::getInt( 'i_'.$i,0,'post' );
		   $priceitemid = JRequest::getInt( 'itemid_'.$i,0,'post' );
		   $filename = JRequest::getVar( 'filename_'.$priceitemid,'','post' );
		   $itemsall[$i] = $priceitemid;
		   if ($chk == 'on' || $cnt >0 ) {
			   if ($chk == 'on')
		   			$items[$j]->count = 1;
			   else
				    $items[$j]->count = $cnt;
				$items[$j]->filename = $filename;
					
			   $items[$j]->id = $priceitemid;
			   $j++;
			}
		}
 	    $tableItems = & JTable::getInstance('Iprice_item', 'JTable');		
		foreach ( $radiogroups as $k) {
		   $chk = (int)JRequest::getVar( 'i_radio_'.$k,'','post' );
		   if ($chk) {
			$tableItems->load($chk);

			if ($tableItems->cost>0) {

				$items[$j]->count = 1;
				$items[$j]->id = $chk;
				$items[$j]->filename = JRequest::getVar( 'filename_'.$chk,'','post' );

				$tableItems->SetQuery('','','','','','',' ipi.showcount=2 and ipi.id<>'.$items[$j]->id.' and ipi.radiogroup = '.$k);
				$rows = $tableItems->GetList();
				foreach ($rows as $row) {
			  		$j++;
					$items[$j]->id = $row->id;
					$items[$j]->count = 0;
					$itemsall[] = $row->id;
				}
				$j++;
			}
		   }
		}
/*		if ($usecart)*/
		$errmess=$this->prepareFiles($items);
		$this->AddToBasket($items, $itemsall);
		
		if ($action === 'sendorder') {
		
			$contact->fio = strip_tags(JRequest::getVar( 'fio','','post' ));
			$contact->firm = strip_tags(JRequest::getVar( 'firm','','post' ));
			$contact->phone = strip_tags(JRequest::getVar( 'phone','','post' ));
			$contact->email = strip_tags(JRequest::getVar( 'email','','post' ));
			$contact->comments = JString::substr( strip_tags(JRequest::getVar( 'comments','','post' )), 0, 1000 );
			
			$cartmode = JRequest::getVar( 'cartmode','','post' );
		
		// Captcha Controller Patch rev. 4.5.0 Stable		

			$dispatcher	= &JDispatcher::getInstance();
			if ( $pparams->get('usecaptcha') == 1 ) {
				$captchaparams = array( JRequest::getVar( 'captchacode', '', 'post' )
				, JRequest::getVar( 'captchasuffix', '', 'post' )
				, JRequest::getVar( 'captchasessionid', '', 'post' ));
				$results = $dispatcher->trigger( 'onCaptchaVerify', $captchaparams );
				if ( ! $results[0] ) {
				
					JError::raiseWarning( 'CAPTHCA', JText::_( 'CAPTCHACODE_DO_NOT_MATCH' ) );
					$this->display($contact, NULL, $cartmode);
					return false;
				}
			}
		}
	
		if ($action == 'basket') {		
			$this->setRedirect($link, JText::_('Basket updated').$errmess);
			return true;
		}
		if ($action == 'makeorder') {
			$scope = $mainframe->scope; //record the scope
			$mainframe->scope = 'com_ipricecalc';  //set scope to component name

			$view = new IPriceCalcViewBasket();
			$model	= new IPriceCalcModelBasket();
		
			if (!JError::isError( $model )) {
				$view->setModel( $model, true );
			}
			// Display the view
			$view->assign('error', $this->getError());
			$view->assign('task',$this->getTask());
			$view->addTemplatePath(JPATH_SITE.DS.'components'.DS.'com_ipricecalc'.DS.'views'.DS.'basket'.DS.'tmpl'.DS);
		
//			$lang =& JFactory::getLanguage();
//			$lang->load('com_ipricecalc');
		
 			$view->display(null, $itemid, null, 'makeorder');
//	по просьбе vagkrsk		$view->display(null, $itemid);

			$mainframe->scope = $scope; //revert the scope		
		
//			$this->setRedirect(JRoute::_('index.php?option=com_ipricecalc&view=basket&task=makeorder&layout=default&itemid='.$itemid, false),'');
			return true;
		}

		$basket =& JTable::getInstance('Iprice_basket', 'JTable');
		$basket->SetQuery();
		if ($usecart) {		
			if (!$basket->GetCount()) {
					//JError::raiseWarning('IPricecalc',JText::_('Select one or more items!'));
					$this->display();
					return false;
			}
		} else {
		   if (!count($items)) {
					JError::raiseWarning('IPricecalc',JText::_('Select one or more items!'));
					$this->display();
					return false;
		   }
		}
		
		$copyemail =  JRequest::getVar( 'copyemail','','post' );
		
		$contact->email_to = '';
		//ВНимание! Исправить на параметр;
		$manageruserid = (int) $pparams->get('manageruserid');
		if (!$manageruserid)
			$manageruserid = 62;
		
		//$msg = 'Manager : '.$manageruserid;
		$contact->user_id = $manageruserid;
		$finishtext = $pparams->get('finishtext',JText::_('Thank you for ordering'));
		

		 // load the contact details
		$model		= &$this->getModel('basket');
		$orderno = $model->getNextOrderNo();
		
//		if ($usecart)
		$items = $basket->GetList();
		$countdig = ($pparams->get('usecents','0') == '1' ? 2 : 0 );
		$salestax = (int)$pparams->get('salestax','0');
		$total = 0.00;
		$taxamount = 0.00;

		$currt =& JTable::getInstance('Iprice_curr', 'JTable');
		$currt->load($curr);
		calcAmount($items, $currt, $countdig, $salestax, $total, $taxamount);
		
		$model->insOrder($items,$contact,$orderno,$curr,$pparams, $salestax, $total, $taxamount);

		if($contact->email_to == '' && $contact->user_id != 0)
		{
			$contact_user = JUser::getInstance($contact->user_id);
			$contact->email_to = $contact_user->get('email');
		}

		if ($contact->email_to && $countitems && (JMailHelper::isEmailAddress($contact->email_to) == true))
		{
			$MailFrom 	= $mainframe->getCfg('mailfrom');
			$FromName 	= $mainframe->getCfg('fromname');
			$body 	= getOrderHTMLPage($orderno);
			// Prepare email body
			$subj =  $FromName.JText::_('E-MAIL SUBJECT').' '.JText::_('ORDER NO').$orderno;
			$files = getOrderFiles($orderno);
			sendMailTo ($contact->email_to, $contact->email, $contact->fio, $subj, $body, $files);
			if ($copyemail == 'on' && $contact->email && (JMailHelper::isEmailAddress($contact->email) == true)) {
				$name_from = $contact_user->get('name');			
				sendMailTo ($contact->email, $contact->email_to, $name_from, $subj, $body, $files);
			}
		}
		$model->emptyBasket();
		
		if ((int)$pparams->get('enableredir') && $pparams->get('redirurl','')) {
			$redir = $pparams->get('redirurl','');
			$redir = str_replace('CURR_CODE',$curr, $redir);
			$redir = str_replace('ORDER_NO',rawurlencode(JText::_('ORDER NUM').$orderno),$redir);
			$redir = str_replace('SUM',rawurlencode($total),$redir);
//			echo $redir;
//			exit;
			$this->setRedirect($redir);
		} else		
			$this->setRedirect($link, $finishtext);

	}
	
	/**
	 * Validates some inputs based on component configuration
	 *
	 * @return Boolean
	 * @access protected
	 * @since 1.5
	 */
	function _validateInputs( $contact, $email, $subject, $body )
	{
		global $mainframe;

		$session =& JFactory::getSession();

		// Get params and component configurations
		$params		= new JParameter($contact->params);
		$pparams	= &$mainframe->getParams('com_contact');

		// check for session cookie
		$sessionCheck 	= $pparams->get( 'validate_session', 1 );
		$sessionName	= $session->getName();
		if  ( $sessionCheck ) {
			if ( !isset($_COOKIE[$sessionName]) ) {
				$this->setError( JText::_('ALERTNOTAUTH') );
				return false;
			}
		}

		// Determine banned e-mails
		$configEmail	= $pparams->get( 'banned_email', '' );
		$paramsEmail	= $params->get( 'banned_mail', '' );
		$bannedEmail 	= $configEmail . ($paramsEmail ? ';'.$paramsEmail : '');

		// Prevent form submission if one of the banned text is discovered in the email field
		if(false === $this->_checkText($email, $bannedEmail )) {
			$this->setError( JText::sprintf('MESGHASBANNEDTEXT', 'Email') );
			return false;
		}

		// Determine banned subjects
		$configSubject	= $pparams->get( 'banned_subject', '' );
		$paramsSubject	= $params->get( 'banned_subject', '' );
		$bannedSubject 	= $configSubject . ( $paramsSubject ? ';'.$paramsSubject : '');

		// Prevent form submission if one of the banned text is discovered in the subject field
		if(false === $this->_checkText($subject, $bannedSubject)) {
			$this->setError( JText::sprintf('MESGHASBANNEDTEXT', 'Subject') );
			return false;
		}

		// Determine banned Text
		$configText		= $pparams->get( 'banned_text', '' );
		$paramsText		= $params->get( 'banned_text', '' );
		$bannedText 	= $configText . ( $paramsText ? ';'.$paramsText : '' );

		// Prevent form submission if one of the banned text is discovered in the text field
		if(false === $this->_checkText( $body, $bannedText )) {
			$this->setError( JText::sprintf('MESGHASBANNEDTEXT', 'Message') );
			return false;
		}

		// test to ensure that only one email address is entered
		$check = explode( '@', $email );
		if ( strpos( $email, ';' ) || strpos( $email, ',' ) || strpos( $email, ' ' ) || count( $check ) > 2 ) {
			$this->setError( JText::_( 'You cannot enter more than one email address', true ) );
			return false;
		}

		return true;
	}

	/**
	 * Checks $text for values contained in the array $array, and sets error message if true...
	 *
	 * @param String	$text		Text to search against
	 * @param String	$list		semicolon (;) seperated list of banned values
	 * @return Boolean
	 * @access protected
	 * @since 1.5.4
	 */
	function _checkText($text, $list) {
		if(empty($list) || empty($text)) return true;
		$array = explode(';', $list);
		foreach ($array as $value) {
			$value = trim($value);
			if(empty($value)) continue;
			if ( JString::stristr($text, $value) !== false ) {
				return false;
			}
		}
		return true;
	}

	function renderIPrice($itemid, $secids = NULL,$catids = NULL,$itemids = NULL) {
	    global $mainframe;
		
		require_once( JPATH_SITE.DS.'components'.DS.'com_ipricecalc'.DS.'views'.DS.'price'.DS.'view.html.php');
		require_once( JPATH_SITE.DS.'components'.DS.'com_ipricecalc'.DS.'models'.DS.'price.php');
		
		$filter	= JRequest::getVar('ifilter','');
		
		$scope = $mainframe->scope; //record the scope
		$mainframe->scope = 'com_ipricecalc';  //set scope to component name

		$view = new IPriceCalcViewPrice();
		$model	= new IPriceCalcModelPrice();
		
		if (!JError::isError( $model )) {
			$view->setModel( $model, true );
		}
		// Display the view
		$view->assign('error', $this->getError());
		$view->assign('task',$this->getTask());
		$view->addTemplatePath(JPATH_SITE.DS.'components'.DS.'com_ipricecalc'.DS.'views'.DS.'price'.DS.'tmpl'.DS);
		
		$lang =& JFactory::getLanguage();
		$lang->load('com_ipricecalc');

		if ($itemid) {
			$menu = & JMenu::getInstance('site');
			$menuitem = $menu->getItem($itemid);
			if (strpos($menuitem->link,'catalog'))
				$layout = 'catalog';
			else $layout = 'default';
		}
		else 
			$layout = 'default';
		
		$contents = null;
		ob_start();
			$view->setLayout($layout);
			$view->display(null, $itemid, null, $filter, $secids, $catids, $itemids);
			$contents = ob_get_contents();
		ob_end_clean();
		$mainframe->scope = $scope; //revert the scope		
		return $contents;
	}
	
	function renderIPriceBasket($itemid) {
	    global $mainframe;

		$scope = $mainframe->scope; //record the scope
		$mainframe->scope = 'com_ipricecalc';  //set scope to component name

		$view = new IPriceCalcViewBasket();
		$model	= new IPriceCalcModelBasket();
		
		if (!JError::isError( $model )) {
			$view->setModel( $model, true );
		}
		// Display the view
		$view->assign('error', $this->getError());
		$view->assign('task',$this->getTask());
		$view->addTemplatePath(JPATH_SITE.DS.'components'.DS.'com_ipricecalc'.DS.'views'.DS.'basket'.DS.'tmpl'.DS);
		
		$lang =& JFactory::getLanguage();
		$lang->load('com_ipricecalc');
		
		$contents = null;
		ob_start();
			$view->display(null, $itemid);
			$contents = ob_get_contents();
		ob_end_clean();
		$mainframe->scope = $scope; //revert the scope		
		return $contents;
	}

}
?>