<?php
/**
* @version		$ 1.2 2009-10$
* @package		Joomla
* @subpackage	IPricecalc
* @copyright	Copyright (C) 2009 LoT studio group. All rights reserved.
* @license		The commercial licence http://www.lot-studio.ru/license-ipricecalc
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );


class JTableIprice_category extends JTable
{
	var $id 					= null;
	var $secid 					= null;
	var $name 				= null;
	var $alias 				= null;
	var $discid				= null;	
	var $description 		= NULL;	

	var $checked_out 		= 0;
	var $checked_out_time 	= 0;
	var $params 				= null;	
	
	var $ordering 				= null;	
	var $published 				= 1;	
	
// internal variables
	var $_query = "";
	var $_querycount = "";
	var $_where	= "";
	var $_orderby	= "";
	
	function __construct(&$db)
	{
		parent::__construct( '#__iprice_categories', 'id', $db );
	}

	function check()
	{
		// check for valid name
		if (trim( $this->name ) == '') {
			$this->setError(JText::sprintf( 'must contain a title', JText::_( 'Category') ));
			return false;
		}

		if(empty($this->alias)) {
			$this->alias = $this->name;
		}
		$this->alias = JFilterOutput::stringURLSafe($this->alias);
		if(trim(str_replace('-','',$this->alias)) == '') {
			$datenow =& JFactory::getDate();
			$this->alias = $datenow->toFormat("%Y-%m-%d-%H-%M-%S");
		}

		return true;
	}
	
	function SetQuery($filter_state = "", $filter_secid = "",$search = "",$filter_order = "", $filter_order_Dir = "", $whe = "")
	{
		$db					=& JFactory::getDBO();
		
		$this->_query = 'SELECT ipc.id as key1, ips.id as key2, ips.name as section, ipc.* FROM #__iprice_categories AS ipc'.
						' LEFT JOIN #__iprice_sections AS ips ON ipc.secid = ips.id';

						;
		$this->_querycount = 'SELECT COUNT(*) FROM #__iprice_categories AS ipc LEFT JOIN #__iprice_sections AS ips ON ipc.secid = ips.id';
		$wh = NULL;

		if ( $search ) {
			$wh[] = 'ipc.name LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}
		if ( $filter_secid && $filter_secid!="-1") {
			$wh[] = 'ipc.secid = '.(int) $filter_secid;
		}
		
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$wh[] = 'ipc.published = 1';
			} else if ($filter_state == 'U' ) {
				$wh[] = 'ipc.published = 0';
			} else if ($filter_state == 'PP' ) {
				$wh[] = 'ipc.published = 1 and ips.published = 1';
			}
		}
		
		if ( $whe ) {
		 	$wh[] = $whe;
		}
		
		$this->_where = ( count( $wh ) ? ' WHERE ' . implode( ' AND ', $wh ) : '' );
		
		if ($filter_order == 'ipc.ordering' || $filter_order == ''){
			$this->_orderby 	= ' ORDER BY ips.ordering '.' '. $filter_order_Dir .', ipc.ordering'.' '. $filter_order_Dir;
		} else {
			$this->_orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir ;
		}
	}
	
	function GetOrderQuery($secid)
	{
	  return 'SELECT ordering AS value, name AS text  FROM #__iprice_categories WHERE secid = '.(int) $secid . ' ORDER BY ordering';
	}
	
	function GetList($limitstart = 0, $limit = 0)
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_query . $this->_where . $this->_orderby, $limitstart, $limit);
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	function GetSectionID($wh = null)
	{
		$db	=& $this->getDBO();
		$query = 'select id from #__iprice_sections AS ips '.($wh!==null ? '  where  '.$wh : '');
		$db->setQuery($query);
		$rows = $db->loadResultArray();
		return $rows;
	}
	
	
	function GetCount()
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_querycount . $this->_where );
		$total = $db->loadResult();
		return $total;
	}
	
}
?>