<?php
/**
* @version		$ 1.2 2009-10$
* @package		Joomla
* @subpackage	IPricecalc
* @copyright	Copyright (C) 2009 LoT studio group. All rights reserved.
* @license		The commercial licence http://www.lot-studio.ru/license-ipricecalc
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );


class JTableIprice_item extends JTable
{
	/** @var int Primary key */
	var $id 					= NULL;
	var $catid 					= NULL;
	/** @var string */
	var $name 					= NULL;
	/** @var string */
	var $shortdesc 				= NULL;
	/** @var string */
	var $description 			= NULL;
	var $checked_out 			= 0;
	var $checked_out_time 		= 0;
	var $params 				= NULL;	
	
	var $cost 					= NULL;
	var $showcount 				= 1;
	var $radiogroup 			= 0;
	
	var $ordering 				= NULL;
	var $published 				= 1;
	var $item_type				= 0;
	var $discid					= NULL;
	var $enable_file			= 0;
	var $unit					= NULL;

// internal variables

	var $_query = "";
	var $_querycount = "";
	var $_where	= "";
	var $_orderby	= "";
	
	/**
	* @param database A database connector object
	*/
	function __construct(&$db)
	{
		parent::__construct( '#__iprice_item', 'id', $db );
	}

	function check()
	{
		return true;
	}
	
	function SetQuery($filter_state = "", $filter_secid = "", $filter_catid = "",$search = "",$filter_order = "", $filter_order_Dir = "", $whe = "")
	{
		$db					=& JFactory::getDBO();
		
		$this->_query = 'SELECT ipi.id as key1, ipc.id as key2, ips.id as key3,ips.name as section, ips.discid as secdiscid, ipc.discid as catdiscid, ipc.name as category, ipc.secid, ipb.itemcount as count, ipi.* ' 
				. ' FROM #__iprice_item AS ipi '
				. ' INNER JOIN #__iprice_categories AS ipc ON ipi.catid = ipc.id'
				. ' INNER JOIN #__iprice_sections AS ips ON ipc.secid = ips.id'
				. ' LEFT OUTER JOIN #__iprice_basket AS ipb ON ipi.id = ipb.itemid and ipb.sessionid ="'.session_id().'"'
				;
		$this->_querycount = 'SELECT count(*) ' 
				. ' FROM #__iprice_item AS ipi '
				. ' INNER JOIN #__iprice_categories AS ipc ON ipi.catid = ipc.id'
				. ' INNER JOIN #__iprice_sections AS ips ON ipc.secid = ips.id'
				;

		$wh = NULL;

//		$wh[] = 'ipb.sessionid ="'.session_id().'"';
		if ( $search ) {
			$wh[] = 'ipi.name LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}
		if ( $filter_catid ) {
			$wh[] = 'ipi.catid in ('.$filter_catid.')';
		}

		if ( $filter_secid) {
			$wh[] = 'ipc.secid in ('. $filter_secid .')';
		}

		
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$wh[] = 'ipi.published = 1';
			} else if ($filter_state == 'U' ) {
				$wh[] = 'ipi.published = 0';
			} else if ($filter_state == 'PP' ) {
				$wh[] = 'ipi.published = 1 and ipc.published = 1 and ips.published = 1 ';
			}
		}
		
		if ( $whe ) {
		 	$wh[] = $whe;
		}
		
		$this->_where = ( count( $wh ) ? implode( ' AND ', $wh ) : '' );
		
		if ($filter_order == 'ipi.ordering' || $filter_order == ''){
			$this->_orderby 	= ' ips.ordering '.' '. $filter_order_Dir .', ipc.ordering '.' '. $filter_order_Dir .', ipi.ordering'.' '. $filter_order_Dir;
		} else {
			$this->_orderby 	=  $filter_order .' '. $filter_order_Dir ;
		}
	}
	
	function GetOrderQuery($catid)
	{
	  return 'SELECT ordering AS value, name AS text  FROM #__iprice_item WHERE catid = '.(int) $catid . ' ORDER BY ordering';
	}
	
	function GetList($limitstart = 0, $limit = 0)
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_query . ($this->_where ? ' where '.$this->_where : '') . ($this->_orderby ? ' order by '.$this->_orderby : ''), $limitstart, $limit);
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	function GetCategoryID($wh = null)
	{
		$db	=& $this->getDBO();
		$query = 'select id from #__iprice_categories AS ipc '.($wh!==null ? ' where  '.$wh : '');
		$db->setQuery($query);
		$rows = $db->loadResultArray();
		return $rows;
	}
	
	
	function GetCount()
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_querycount . ($this->_where ? ' where '.$this->_where : '') );
		$total = $db->loadResult();
		return $total;
	}
	
	function GetRadioGroups()
	{
		$db	=& JFactory::getDBO();
		$db->setQuery( 'select distinct radiogroup from #__iprice_item');
		$rows = $db->loadResultArray();
		return $rows;
	}
	
}

class JTableIprice_order extends JTable
{
	var $orderno			= null;
	var $orderdate			= null;
	var $fio 				= null;
	var $firm 				= null;
	var $email 				= null;
	var $phone 				= 0;
	var $comments 			= 0;
	var $totalamount 		= null;	
	var $salestax 			= null;	
	var $taxamount 				= null;	
	var $usecents 				= 1;
	var $showprices				= 1;
	var $showorderdesc			= 1;
	
	var $istemplate 		= 0;
	var $templatename 		= NULL;
	
	var $checked_out 		= 0;
	var $checked_out_time 	= 0;
	var $userid 			= 62;

// internal variables

	var $_query = "";
	var $_querycount = "";
	var $_where	= "";
	var $_orderby	= "";
	
	function __construct(&$db)
	{
		parent::__construct( '#__iprice_order_main', 'orderno', $db );
	}

	function check()
	{
		return true;
	}

	function deleteFiles($orderno) {
		$files = $this->getOrderFiles ($orderno);
		for ($i=0;$i<count($files);$i++) {
			unlink($files[$i]);
			echo $files[$i]."<br>";
		}
//		exit;
	}
	
	// overloaded delete function
	function delete( $oid=null )
	{
		if ( parent::delete( $oid ) && ( $oid ))
		{
			$this->deleteFiles($oid);
			$query = 'DELETE FROM #__iprice_order'
			. ' WHERE orderno = '.(int) $oid
			;
			$this->_db->setQuery( $query );
			if ( !$this->_db->query() ) {
				$this->_error .= $this->_db->getErrorMsg() . "\n";
			}
			return true;
		}

		return false;
	}
	
	function SetQuery($search = "",$filter_order = "", $filter_order_Dir = "")
	{
		$db					=& JFactory::getDBO();
		
		$this->_query = 'SELECT ipom.orderno as id, ipom.* FROM #__iprice_order_main AS ipom ';
		$this->_querycount = 'SELECT COUNT(*) FROM #__iprice_order_main AS ipom ';
		$wh = NULL;
		if ( $search ) {
			$wh[] = 'ipom.fio LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}
		$this->_where = ( count( $wh ) ? ' WHERE ' . implode( ' AND ', $wh ) : '' );
		
		if ($filter_order == 'ipom.orderno' || $filter_order == ''){
			$this->_orderby 	= ' ORDER BY ipom.orderno '. $filter_order_Dir;
		} else {
			$this->_orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir ;
		}
	}
	
	function GetList($limitstart = 0, $limit = 0)
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_query . $this->_where . $this->_orderby, $limitstart, $limit);
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	function GetCount()
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_querycount . $this->_where );
		$total = $db->loadResult();
		return $total;
	}
	
	function getOrder( $orderno )
	{
		$db = JFactory::getDBO();
		$query = 'select * from #__iprice_order_main where orderno = '. (int) $orderno;
		$db->setQuery($query);
		$order = $db->loadObject();
		return $order;
	}
	
	function getOrderItems( $orderno )
	{
		/*
		$query = 'select ipi.id as key1, ipc.id as key2, ips.id as key3,ips.name as section, ipc.name as category, ipc.secid, ipi.catid, ipi.name, ipi.shortdesc, ipi.description, ipo.* from #__iprice_order as ipo '.
			' INNER JOIN #__iprice_item AS ipi ON ipo.itemid = ipi.id '.
			' INNER JOIN #__iprice_categories AS ipc ON ipi.catid = ipc.id '.
			' INNER JOIN #__iprice_sections AS ips ON ipc.secid = ips.id'.
			' where orderno = '.(int) $orderno. ' ORDER BY ips.ordering, ipc.ordering, ipi.ordering';
			*/
		$query = 'select * from #__iprice_order where orderno = '.(int) $orderno. ' order by id';
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$items = $db->loadObjectList();
		return $items;
	}
	
	function getOrderFiles ($orderno) {
		$db = JFactory::getDBO();	
		$query = 'SELECT distinct filename from #__iprice_order where orderno='.$orderno.' and filename<>"" ';
		$db->setQuery($query);
		$files = $db->loadResultArray();
		return $files; 
	}
	
}

class JTableIprice_curr extends JTable
{
	var $currcode			= null;
	var $currdate			= null;
	var $rate 				= 1;
	var $symbol 			= null;
	var $symplace 			= null;
	var $usespace 			= null;
	var $checked_out 		= 0;
	var $checked_out_time 	= 0;

// internal variables

	var $_query = "";
	var $_querycount = "";
	var $_where	= "";
	var $_orderby	= "";
	
	function __construct(&$db)
	{
		parent::__construct( '#__iprice_curr', 'currcode', $db );
		$this->currdate			= date('Y.m.d H:i:s');
	}

	function check()
	{
		return true;
	}
	
	function SetQuery($search = "",$filter_order = "", $filter_order_Dir = "")
	{
		$db					=& JFactory::getDBO();
		
		$this->_query = 'SELECT currcode as id, cu.* FROM #__iprice_curr cu';
		$this->_querycount = 'SELECT COUNT(*) FROM #__iprice_curr';
		$wh = NULL;
		if ( $search ) {
			$wh[] = 'currcode LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}
		$this->_where = ( count( $wh ) ? ' WHERE ' . implode( ' AND ', $wh ) : '' );
		
		if ($filter_order == 'currcode' || $filter_order == ''){
			$this->_orderby 	= ' ORDER BY currcode '. $filter_order_Dir;
		} else {
			$this->_orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir ;
		}
	}
	
	function GetList($limitstart = 0, $limit = 0)
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_query . $this->_where . $this->_orderby, $limitstart, $limit);
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	function GetCount()
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_querycount . $this->_where );
		$total = $db->loadResult();
		return $total;
	}
	
	function insert()
	{
		$db = & $this->_db;
		$query = 'insert into #__iprice_curr values('.$db->Quote(strtoupper($this->currcode)).','.$db->Quote($this->currdate).','.$this->rate.','.$db->Quote($this->symbol).','.$this->symplace.','.$this->usespace.',0,0)';
		$this->_db->setQuery( $query );
		if ( !$this->_db->query() ) {
			$this->_error .= $this->_db->getErrorMsg() . "\n";
			return false;
		}
		return true;
	}
	
}

if (!class_exists('DateTime')) {

if (!defined('DATE_ATOM')) { define('DATE_ATOM', 'Y-m-d\TH:i:sP' ); }

class DateTime {
    var $date;
   
    function __construct($date) {
        $this->date = strtotime($date);
    }
   
    function setTimeZone($timezone) {
        return;
    }
   
    function __getDate() {
        return date(DATE_ATOM, $this->date);   
    }
   
    function modify($multiplier) {
        $this->date = strtotime($this->__getDate() . ' ' . $multiplier);
    }
   
    function format($format) {
        return date($format, $this->date);
    }
}
}


class JTableIprice_basket extends JTable
{
	/** @var int Primary key */
	var $id 					= null;
	var $sessionid 				= null;
	var $itemid 				= null;
	var $itemcount 				= null;
	var $date 					= null;	
	var $filename				= NULL;	
	var $tmp_dirname			= NULL;
	var $tmp_filename			= NULL;

// internal variables

	var $_query = "";
	var $_querycount = "";
	var $_where	= "";
	var $_orderby	= "";

	/**
	* @param database A database connector object
	*/
	function __construct(&$db)
	{
		parent::__construct( '#__iprice_basket', 'id', $db );
	}

	function check()
	{
		return true;
	}
	
	function SetQuery($filter_state = "", $filter_catid = "",$search = "",$filter_order = "", $filter_order_Dir = "", $whe = "", $filter_secid = -1)
	{
		$db					=& JFactory::getDBO();

		$this->_query = 'SELECT ipi.id as key1, ipc.id as key2, ips.id as key3,ips.name as section, ips.discid as secdiscid, ipc.discid as catdiscid, ipc.name as category, ipc.secid, ipb.itemcount as count, ipb.filename, ipb.tmp_filename, ipb.tmp_dirname, ipi.* FROM #__iprice_item AS ipi'.
						' INNER JOIN #__iprice_categories AS ipc ON ipi.catid = ipc.id'.
						' INNER JOIN #__iprice_sections AS ips ON ipc.secid = ips.id'.
						' INNER JOIN #__iprice_basket AS ipb ON ipi.id = ipb.itemid';


		$this->_querycount = 'SELECT COUNT(*) FROM #__iprice_item AS ipi'.
						' INNER JOIN #__iprice_categories AS ipc ON ipi.catid = ipc.id'.
						' INNER JOIN #__iprice_sections AS ips ON ipc.secid = ips.id'.
						' INNER JOIN #__iprice_basket AS ipb ON ipi.id = ipb.itemid';
		$wh = NULL;
		$wh[] = 'ipb.sessionid ="'.session_id().'"';
		if ( $search ) {
			$wh[] = 'ipi.name LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}
		if ( $filter_catid ) {
			$wh[] = 'ipi.catid = '.(int) $filter_catid;
		}

		if ( (int)$filter_secid > 0 ) {
			$wh[] = 'ipc.secid = '.(int) $filter_secid;
		}

		
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$wh[] = 'ipi.published = 1';
			} else if ($filter_state == 'U' ) {
				$wh[] = 'ipi.published = 0';
			} else if ($filter_state == 'PP' ) {
				$wh[] = 'ipi.published = 1 and ipc.published = 1 and ips.published = 1 ';
			}
		}
		
		if ( $whe ) {
		 	$wh[] = $whe;
		}
		
		$this->_where = ( count( $wh ) ? ' WHERE ' . implode( ' AND ', $wh ) : '' );
		
		$this->_orderby 	= ' ORDER BY ips.ordering,ipc.ordering, ipi.ordering';
	}
	
	function GetList($limitstart = 0, $limit = 0)
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_query . $this->_where . $this->_orderby, $limitstart, $limit);
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	function GetBasketIDs($wh = null)
	{
		$db	=& $this->getDBO();
		$query = 'select id from #__iprice_basket AS ipb where ipb.sessionid="'.session_id().'"'.($wh!==null ? ' and '.$wh : '');
		$db->setQuery($query);
		$rows = $db->loadResultArray();
		return $rows;
	}
	
	function GetCategoryID($wh = null)
	{
		$db	=& $this->getDBO();
		$query = 'select id from #__iprice_categories AS ipc '.($wh!==null ? ' where '.$wh : '');
		$db->setQuery($query);
		$rows = $db->loadResultArray();
		return $rows;
	}
	
	function deleteItems( $ids=null )
	{
	    if (!$ids || !count($ids))
			return false;
			
		$query = 'DELETE FROM #__iprice_basket WHERE sessionid="'.session_id().'" and id in ('.implode(',',$ids).')';
		$this->_db->setQuery( $query );
		if ( !$this->_db->query() ) {
			$this->_error .= $this->_db->getErrorMsg() . "\n";
		}
		return true;
	}

	function emptySession()
	{
		$query = 'DELETE FROM #__iprice_basket WHERE sessionid="'.session_id().'"';
		$this->_db->setQuery( $query );
		if ( !$this->_db->query() ) {
			$this->_error .= $this->_db->getErrorMsg() . "\n";
		}
		
		$d=date('Y-m-d H:i:s');
		$date = new DateTime($d);
		$date->modify("-2 days");
		$date->format('Y-m-d H:i:s');
		
		$query = 'DELETE FROM #__iprice_basket WHERE date<"'.$date->format('Y-m-d H:i:s').'"';
		$this->_db->setQuery( $query );
		if ( !$this->_db->query() ) {
			$this->_error .= $this->_db->getErrorMsg() . "\n";
		}
		
		return true;
	}
	
	
	function GetCount()
	{
		$db	=& $this->getDBO();
		$db->setQuery( $this->_querycount . $this->_where );
		$total = $db->loadResult();
		return $total;
	}
	
	function getCartSummary()
	{
		$db	=& $this->getDBO();
		$query = "select sum(itemcount) as totalqty, sum(total*itemcount) as totalamount FROM #__iprice_basket where sessionid =\"".session_id()."\"";
		$db->setQuery( $query );
		$total = $db->loadObject();
		return $total;
	}
	
	function AddToBasket( &$items, &$itemsall)
	{
		if (count($itemsall)) {
			$ids = $this->GetBasketIDs(' itemid in ('.implode(',',$itemsall).')');
			$this->deleteItems($ids);
		}
		
		for ($i=0;$i<count($items);$i++)
		{
			//echo $items[$i]->id.':'.$items[$i]->cnt.' ;';
		   $ids = $this->GetBasketIDs(' itemid='.$items[$i]->id);
		   $this->id=0;
		   if (count($ids)) {
				$this->load($ids[0]);
			}
		   $this->sessionid = session_id();
		   $this->itemid = $items[$i]->id;
		   $this->itemcount = (int)$items[$i]->count;
		   $this->filename = $items[$i]->filename;
		   $this->tmp_dirname = $items[$i]->tmp_dirname;
		   $this->tmp_filename = $items[$i]->tmp_filename;
//		   $this->total = $items[$i]->costbasecurr;
		   if (!$this->store()) {
				JError::raiseError(500, $this->getError());
		   }
		}
	}
}
?>